#include "structs.h"
#define MPAM 1
#define PROTDIST 2
#define EDIT 3
#define PAM250Dist 4
#define PAM250Matrix 1
#define MPAMMatrix 2
#define MAX 9999

typedef struct cell
{
  short i[26];
  short from[26];
  char m[26];
} cell;

int pairscore (char *A, char *B, int X, int Y, int *aa, int *bb, char *AA,
	       char *BB, cell ** pairSpace, int **costDist);
char *median (cell *** score, int X, int Y, int Z, char *A, char *B, char *C);
void AffineTAMSAscoreProMPAM (char *A, char *B, char *C, int X, int Y,
			      int Z, int **costDist, int s1, int s2);
void
scoreThree (char *A, char *B, char *C, int X, int Y, int Z,
	    int **cost, int *aa, int *bb, int *cc, int state);
void
alignTwo (char *B, char *C, int Y, int Z, int **cost, int *bb, int *cc,
	  int start, int end);
void setALmatrix (int **distmatrix, struct genome_struct *genomes,
		  int num_genes, int num_genomes, cell ** pairSpace,
		  int CIRCULAR, int **costDist, int *aa,
		  int *bb, char *AA, char *BB);

void cleanCell (cell *** score, struct genome_struct *gen1,
		struct genome_struct *gen2, struct genome_struct *gen3);
void condenseGap (char *answer, int *length);
void convertArray (char *A, int *aa, int length);
void revString (char *A);
void revNewString (char *A, int len, char *revA);
int convertState (int in);
int scan_pair (char *A, char *B, int **cost);
void h_median (char *A, char *B, char *C, int X, int Y, int Z,
	       cell ** pairSpace, int **costDost);
