#include "transfer.h"
void
toGestalt (struct tNode *tree, char *fname)
{
  char fname1[128];
  FILE *f1;
  sprintf (fname1, "%s.ges", fname);
  f1 = fopen (fname1, "w");
  if (tree->parent != NULL)
    {
      printf ("Sorry, should start from the root node\n");
      exit (-1);
    }
  fprintf (f1, "I 2\n");
//    fprintf(stderr, "I 2\n");
  rec2Gestalt (tree->lChild, f1);
  fprintf (f1, "L %d\n", tree->tag);
  //   fprintf(stderr, "L %d\n", tree->tag);
  fclose (f1);
  return;
}

void
rec2Gestalt (struct tNode *tree, FILE * f1)
{
  if (tree == NULL)
    return;
  if (tree->tag < 0)
    {
      fprintf (f1, "I 2\n");
//      fprintf(stderr, "I 2\n");
    }
  if (tree->leaf)
    {
      fprintf (f1, "L %d\n", tree->tag);
      //       fprintf(stderr, "L %d\n", tree->tag);
    }
  rec2Gestalt (tree->lChild, f1);
  rec2Gestalt (tree->rChild, f1);
  return;
}

void
assignGinternals (struct tNode *tree, char **internals, int *internalNum)
{
  if (tree->parent != NULL)
    {
      printf ("Sorry, should start from the root node\n");
      exit (-1);
    }
  //fprintf(stderr, "Begin assigning internal seqs...\n");
  rec2Ginternals (tree->lChild, internals, internalNum);
  return;
}

void
rec2Ginternals (struct tNode *tree, char **internals, int *internalNum)
{
  int i = 0;
  if (tree == NULL)
    return;
  if (tree->tag < 0)
    {
      // fprintf(stderr, "\nassign internal no%d and its tag is %d.\n", *internalNum, tree->tag);
      tree->genome->genes = internals[*internalNum + 1];
      while (tree->genome->genes[i] != '\n')
	i++;
      //fprintf(stderr, "%c", tree->genome->genes[i++]);
      tree->genome->num_chars = i;
      // fprintf(stderr, "Genome_num: %d.\n", i);
      *internalNum = *internalNum + 1;
    }
  rec2Ginternals (tree->lChild, internals, internalNum);
  rec2Ginternals (tree->rChild, internals, internalNum);
  return;
}
